let r; //declares "r" variable
let v; //declares "v" variable
let factor = 0; //declares "factor" variable and assigns it equals to 0 
let song1; //declares "song1" variable
let song2; //declares "song2" variable
let song3; //declares "song3" variable
let amp;  //declares "amp" variable
let l = 150; //declares "l" variable and equates it to 150
let angle = 0; //declares "angle" variable and assigns it equals to 0


function preload(){ // peloads media assets before setup function
  song1 = loadSound("songs/song1.mp3"); // preloads song 1 
  song2 = loadSound("songs/song2.mp3"); // preloads song 2
  song3 = loadSound("songs/song3.mp3"); // preloads song 3
}


function setup() { //runs to start program
  getAudioContext().suspend(); //allows user to conrol start of sound by stopping it from playing at setup
  song1.play(); //starts playing song1
  amp = new p5.Amplitude(); //measures amplitude of sound in p5
  createCanvas(1000,800); //sets canvas width and  height
  r = height / 2 - 16; //sets the size of the ellipse state 1

  amp = new p5.Amplitude();//measures amplitude of sound in p5
}

function getVector(index, total) { //creates vector
  const angle = map( index % total, 0, total, 0, TWO_PI); //sets angle at which strokes draw from in ellipse
  const v = p5.Vector.fromAngle(angle + 0); // gives the constant v this value 
  v.mult(r); //v set to r
  return v; //specifies value to be returned by function
}

function draw() { // sets function to draw continuously 

  switch(key){ //sets statments to be associated with specific case

   case "1": //calls case 1
    default: //sets as default screen 
        background(229,185,280); //sets background color when case 1 ia pressed
        const total = 700; //sets total number of strokes in ellipse
        factor += 0.015; //sets the speed of strokes inside the ellipse
        
        translate(width / 2, height / 2); //sets position of ellipse
        stroke(255, 200); //sets stroke color 
        strokeWeight(0.5); //sets stroke thickness
        fill(207,159,255); //fills ellipse with color
        ellipse(0, 0, r * 2); //draws ellipse 
        

        strokeWeight(3); //sets stroke thickness

        for (let i = 0; i < total; i++) { //creates a forloop 
          const a = getVector(i, total); //creates constant a
          const b = getVector(i * factor, total);//creates constant b
          line(a.x, a.y, b.x, b.y); //sets where lines are drawn from
        }

       
  
        break; //terminates playing loop
 

   case"2": //calls case 2
      
          background(204,204,255); //sets background color  when case 2 ia pressed

          
          let level = amp.getLevel(); //sets level to equal amplitude
          let middle = width/2; //sets width of circle
          let circleSize = map(level, 0, 1, 0,middle); // sets circle size to map with level which reacts to amplitude
          noStroke(); //does not draw stroke around circle
         
         
          fill(126,92,155); //adds color 
          circle(middle, 100, circleSize); //sets first circles position on canvas
         
          fill(229,185,280); //adds color 
          circle(middle, height / 2 , circleSize); //sets middle circles position on canvas

          fill(218,112,214); //adds color 
          circle(middle, 700  , circleSize); //sets last circles position on canvas
         

        break; //terminates playing loop


        case"3": //calls case 3
        
        background(216,191,216,10); //sets background color  when case 3 ia pressed
        
        
  

  translate(500, 400); //set to draw point in loops with draw function 
  strokeWeight(16); //sets stroke thickness
  stroke(0); //sets stroke color to black
  let x = l * cos(angle); //assigns position for variable x
  let y = l * sin(angle); //assigns position for variable y
 point(x, y); // sets point x,y on canvas 

  angle += 0.015; //sets angle value
  l -= random(-2, 2); //sets variable value


      
        
        

      break; //terminates playing loop
    }
      }


  function keyPressed() { //calls function for everytime a key is pressed

    switch(key){  //allows the action of switching between keys

      case "1": //calls case 1 to begin action when its pressed
      console.log("stop 2, start 1, stop 3"); //sets message to web console to stop song 2 and 3 and start1
     song2.stop(); //stops playing song2



     if(song1.isPlaying() == false){ // "if" statment if song 1 is not playing starts song 1 when case 1 is pressed
      song1.play(); //starts playing song1
     }



     song3.stop(); //stops playing song3
      break; //terminates playing loop

      case "2": //calls case 2 to begin action when its pressed
        console.log("stop 1, start 2, stop 3"); //sets message to web console to stop song 1 and 3 and start2
        song1.stop(); //stops playing song1
       
        if(song2.isPlaying() == false){ // "if" statment if song 2 is not playing starts song 2 when case 2 is pressed
          song2.play(); //starts playing song2
         }
    
        
        song3.stop();//stops playing song3
      break; //terminates playing loop

      case "3": //calls case 3 to begin action when its pressed
        background(216,191,216); //sets background color  when case 3 ia pressed
        console.log("stop 2, start 3 stop 1"); //sets message to web console to stop song 1 and 2 and start3
        song2.stop(); //stops playing song2
        
        if(song3.isPlaying() == false){ // "if" statment if song 3 is not playing starts song 3 when case 3 is pressed
          song3.play(); //starts playing song3
         }
    
        song1.stop(); //stops playing song1
      break; //terminates playing loop
    }

  }

  function mousePressed() { //begins action only when mouse is pressed
    userStartAudio(); //audio begins when mouse is pressed
  } 